package hr.fer.zemris.seminar.ajnc;

import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.nio.file.Path;
import java.util.Random;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.WindowConstants;

public class IgraProtivAI extends JFrame {
	private static boolean djeliteljevRed = false;
	private static boolean igracevRed = true;
	private static boolean protivnikovRed = false;

	private static final long serialVersionUID = 1L;
	private static AIprotivnik protivnik;

	private static PosaoProtivnika radnaDretvaProtivnika;
	private JLabel labelaPovlacenjaProtivnika;
	private JLabel labelaBodovaProtivnika;

	private static PosaoDjelitelja radnaDretvaDjelitelja;
	private JLabel labelaPovlacenjaDjelitelja;
	private JLabel labelaBodovaDjelitelja;

	private static PosaoIgraca radnaDretvaIgraca;
	private JLabel labelaPovlacenjaIgraca;
	private JLabel labelaBodovaIgraca;
	private JButton hitGumbIgraca;
	private JButton standGumbIgraca;

	private static JLabel labelaPobjedaIgracaNadAI;
	private static JLabel labelaPobjedaAINadIgracem;
	private static JLabel labelaPobjedaIgraca;
	private static JLabel labelaPobjedaAI;

	private static int brojPobjedaIgracaAI = 0;
	private static int brojPobjedaIgracaDealer = 0;
	private static int brojPobjedaAIIgrac = 0;
	private static int brojPobjedaAIDealer = 0;

	public static RandomMultiDeck deck = new RandomMultiDeck(5);

	private static String trenutniInputIgraca = null;

	private static int[] vrijednostiKarata = new int[] { 11, 2, 3, 4, 5, 6, 7,
			8, 9, 10, 10, 10, 10 };

	public IgraProtivAI() {
		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
			e.printStackTrace();
		}

		setLocation(0, 0);
		setSize(1000, 300);
		setTitle("Ajnc AI test");

		initGUI();

		addWindowListener(new WindowListener() {

			@Override
			public void windowOpened(WindowEvent e) {
				if (radnaDretvaDjelitelja == null) {
					radnaDretvaDjelitelja = new PosaoDjelitelja(
							labelaPovlacenjaDjelitelja, labelaBodovaDjelitelja);
					radnaDretvaDjelitelja.start();
				}
				if (radnaDretvaProtivnika == null) {
					radnaDretvaProtivnika = new PosaoProtivnika(
							labelaPovlacenjaProtivnika, labelaBodovaProtivnika);
					radnaDretvaProtivnika.start();
				}

				if (radnaDretvaIgraca == null) {
					radnaDretvaIgraca = new PosaoIgraca(labelaPovlacenjaIgraca,
							labelaBodovaIgraca, hitGumbIgraca, standGumbIgraca);
					radnaDretvaIgraca.start();
				}
			}

			@Override
			public void windowIconified(WindowEvent e) {
			}

			@Override
			public void windowDeiconified(WindowEvent e) {
			}

			@Override
			public void windowDeactivated(WindowEvent e) {
			}

			@Override
			public void windowClosing(WindowEvent e) {
			}

			@Override
			public void windowClosed(WindowEvent e) {
				djeliteljevRed = igracevRed = protivnikovRed = false;
				
				if (radnaDretvaDjelitelja != null) {
					radnaDretvaDjelitelja.interrupt();
					radnaDretvaDjelitelja = null;
				}
				if (radnaDretvaProtivnika != null) {
					radnaDretvaProtivnika.interrupt();
					radnaDretvaProtivnika = null;
				}

				if (radnaDretvaIgraca != null) {
					radnaDretvaIgraca.interrupt();
					radnaDretvaIgraca = null;
				}
				
			}

			@Override
			public void windowActivated(WindowEvent e) {
			}
		});
	}

	private static class PosaoDjelitelja extends Thread {
		public int sumaDjelitelja;
		private boolean asIzvucen = false;
		private boolean asIskoristen = false;

		public JLabel labelaPovlacenja;
		public JLabel labelaBodova;

		public PosaoDjelitelja(JLabel labela, JLabel labela2) {
			this.labelaPovlacenja = labela;
			this.labelaBodova = labela2;
		}

		public void reset() {
			this.sumaDjelitelja = 0;
			this.asIzvucen = false;
			this.asIskoristen = false;
		}

		@Override
		public void run() {
			super.run();
			asIskoristen = false;
			asIzvucen = false;

			while (true) {
				SwingUtilities.invokeLater(new Runnable() {

					@Override
					public void run() {

						if (djeliteljevRed) {
							String tekst = "";
							int i = new Random().nextInt(13);
							i = deck.drawNextCard();

							protivnik.changeCardCount(i);
							System.out.println("Current card count: "
									+ protivnik.cardCount);
							sumaDjelitelja += vrijednostiKarata[i];
							if (sumaDjelitelja > 21 && asIzvucen
									&& !asIskoristen) {
								sumaDjelitelja -= 10;
								asIskoristen = true;
							}

							switch (i) {
							case 0:
								tekst = "Djelitelj je vukao asa";
								asIskoristen = false;
								asIzvucen = true;
								break;
							case 1:
								tekst = "Djelitelj je vukao dvojku";
								break;
							case 2:
								tekst = "Djelitelj je vukao trojku";
								break;
							case 3:
								tekst = "Djelitelj je vukao cetvorku";
								break;
							case 4:
								tekst = "Djelitelj je vukao peticu";
								break;
							case 5:
								tekst = "Djelitelj je vukao sesticu";
								break;
							case 6:
								tekst = "Djelitelj je vukao sedmicu";
								break;
							case 7:
								tekst = "Djelitelj je vukao osmicu";
								break;
							case 8:
								tekst = "Djelitelj je vukao devetku";
								break;
							case 9:
								tekst = "Djelitelj je vukao desetku";
								break;
							case 10:
								tekst = "Djelitelj je vukao decka";
								break;
							case 11:
								tekst = "Djelitelj je vukao damu";
								break;
							case 12:
								tekst = "Djelitelj je vukao kralja";
								break;
							}

							if (sumaDjelitelja > 21 && asIzvucen
									&& !asIskoristen) {
								sumaDjelitelja -= 10;
								asIskoristen = true;
							}

							labelaPovlacenja.setText(tekst);
							labelaBodova.setText("Suma bodova djelitelja je "
									+ String.valueOf(sumaDjelitelja));

							if (sumaDjelitelja > 16) {
								if (sumaDjelitelja > 21
										&& radnaDretvaIgraca.sumaBodova <= 21)
									brojPobjedaIgracaDealer++;

								if (sumaDjelitelja > 21
										&& radnaDretvaProtivnika.sumaBodova <= 21)
									brojPobjedaAIDealer++;

								if (sumaDjelitelja <= 21
										&& radnaDretvaIgraca.sumaBodova <= 21)
									if (radnaDretvaIgraca.sumaBodova > sumaDjelitelja)
										brojPobjedaIgracaDealer++;

								if (sumaDjelitelja <= 21
										&& radnaDretvaProtivnika.sumaBodova <= 21)
									if (radnaDretvaProtivnika.sumaBodova > sumaDjelitelja)
										brojPobjedaAIDealer++;

								if (radnaDretvaIgraca.sumaBodova <= 21
										&& radnaDretvaProtivnika.sumaBodova > 21)
									brojPobjedaIgracaAI++;

								if (radnaDretvaProtivnika.sumaBodova <= 21
										&& radnaDretvaIgraca.sumaBodova > 21)
									brojPobjedaAIIgrac++;

								if (radnaDretvaProtivnika.sumaBodova <= 21
										&& radnaDretvaIgraca.sumaBodova <= 21) {
									if (radnaDretvaProtivnika.sumaBodova > radnaDretvaIgraca.sumaBodova)
										brojPobjedaAIIgrac++;
									if (radnaDretvaIgraca.sumaBodova > radnaDretvaProtivnika.sumaBodova)
										brojPobjedaIgracaAI++;
								}

								labelaPobjedaAI.setText(String
										.valueOf(brojPobjedaAIDealer));
								labelaPobjedaIgraca.setText(String
										.valueOf(brojPobjedaIgracaDealer));
								labelaPobjedaAINadIgracem.setText(String
										.valueOf(brojPobjedaAIIgrac));
								labelaPobjedaIgracaNadAI.setText(String
										.valueOf(brojPobjedaIgracaAI));

								djeliteljevRed = false;
								igracevRed = true;
								protivnikovRed = false;
								radnaDretvaProtivnika.reset();
								radnaDretvaProtivnika.sumaBodova = 0;
								radnaDretvaIgraca.reset();
								radnaDretvaIgraca.sumaBodova = 0;

								labelaBodova.setText("Konacna suma bodova: "
										+ String.valueOf(sumaDjelitelja));

								radnaDretvaIgraca.labelaBodova.setText("");
								radnaDretvaIgraca.labelaPovlacenja.setText("");

								System.out.println("Dealer stopping on "
										+ sumaDjelitelja);

								return;
							}

						}
					}
				});
				try {
					Thread.sleep(3000);
				} catch (Exception ignorable) {
				}
			}
		}
	}

	private static class PosaoIgraca extends Thread {
		public int sumaBodova;
		private boolean asIzvucen = false;
		private boolean asIskoristen = false;

		private JButton gumbHit;
		private JButton gumbStand;

		public JLabel labelaPovlacenja;
		public JLabel labelaBodova;

		public PosaoIgraca(JLabel labela, JLabel labela2, JButton gumbHit,
				JButton gumbStand) {
			this.labelaPovlacenja = labela;
			this.labelaBodova = labela2;
			this.gumbHit = gumbHit;
			this.gumbStand = gumbStand;

			this.gumbHit.addActionListener(new ActionListener() {

				@Override
				public void actionPerformed(ActionEvent e) {
					System.out.println("HIT!");
					trenutniInputIgraca = "HIT";
				}
			});

			this.gumbStand.addActionListener(new ActionListener() {

				@Override
				public void actionPerformed(ActionEvent e) {
					System.out.println("STAND!");
					trenutniInputIgraca = "STAND";

				}
			});
		}

		public void reset() {
			this.sumaBodova = 0;
			this.asIzvucen = false;
			this.asIskoristen = false;
		}

		@Override
		public void run() {
			super.run();
			asIskoristen = false;
			asIzvucen = false;

			while (true) {
				SwingUtilities.invokeLater(new Runnable() {

					@Override
					public void run() {

						if (igracevRed) {
							String tekst = "";

							if (trenutniInputIgraca != null)
								if (!trenutniInputIgraca.equals("STAND")) {

									radnaDretvaDjelitelja.labelaBodova
											.setText("");
									radnaDretvaDjelitelja.labelaPovlacenja
											.setText("");

									radnaDretvaProtivnika.labelaBodova
											.setText("");
									radnaDretvaProtivnika.labelaPovlacenja
											.setText("");

									int i = new Random().nextInt(13);
									i = deck.drawNextCard();

									protivnik.changeCardCount(i);
									System.out.println("Current card count: "
											+ protivnik.cardCount);
									sumaBodova += vrijednostiKarata[i];
									if (sumaBodova > 21 && asIzvucen
											&& !asIskoristen) {
										sumaBodova -= 10;
										asIskoristen = true;
									}

									switch (i) {
									case 0:
										tekst = "Igrac je vukao asa";
										asIzvucen = true;
										asIskoristen = false;
										break;
									case 1:
										tekst = "Igrac je vukao dvojku";
										break;
									case 2:
										tekst = "Igrac je vukao trojku";
										break;
									case 3:
										tekst = "Igrac je vukao cetvorku";
										break;
									case 4:
										tekst = "Igrac je vukao peticu";
										break;
									case 5:
										tekst = "Igrac je vukao sesticu";
										break;
									case 6:
										tekst = "Igrac je vukao sedmicu";
										break;
									case 7:
										tekst = "Igrac je vukao osmicu";
										break;
									case 8:
										tekst = "Igrac je vukao devetku";
										break;
									case 9:
										tekst = "Igrac je vukao desetku";
										break;
									case 10:
										tekst = "Igrac je vukao decka";
										break;
									case 11:
										tekst = "Igrac je vukao damu";
										break;
									case 12:
										tekst = "Igrac je vukao kralja";
										break;
									}

									if (sumaBodova > 21 && asIzvucen
											&& !asIskoristen) {
										sumaBodova -= 10;
										asIskoristen = true;
									}
									
									labelaPovlacenja.setText(tekst);
									labelaBodova.setText("Suma bodova igraca je "
											+ String.valueOf(sumaBodova));
								}
							if (trenutniInputIgraca == null)
								return;

							if (trenutniInputIgraca.equals("HIT")
									&& sumaBodova < 21)
								trenutniInputIgraca = null;

							if ((trenutniInputIgraca.equals("STAND") || sumaBodova >= 21)
									&& sumaBodova > 0) {
								igracevRed = false;
								djeliteljevRed = false;
								protivnikovRed = true;
								radnaDretvaProtivnika.reset();
								radnaDretvaProtivnika.sumaBodova = 0;

								labelaBodova.setText("Konacna suma bodova: "
										+ String.valueOf(sumaBodova));

								System.out.println("User stopping on "
										+ sumaBodova);
								return;
							}

						}
					}
				});
				try {
					Thread.sleep(3000);
				} catch (Exception ignorable) {
				}
			}
		}
	}

	private static class PosaoProtivnika extends Thread {
		public int sumaBodova;
		private boolean asIzvucen = false;
		private boolean asIskoristen = false;

		public JLabel labelaPovlacenja;
		public JLabel labelaBodova;

		public PosaoProtivnika(JLabel labela, JLabel labela2) {
			this.labelaPovlacenja = labela;
			this.labelaBodova = labela2;
		}

		public void reset() {
			this.sumaBodova = 0;
			this.asIzvucen = false;
			this.asIskoristen = false;
		}

		@Override
		public void run() {
			super.run();
			asIskoristen = false;
			asIzvucen = false;

			while (true) {
				SwingUtilities.invokeLater(new Runnable() {

					@Override
					public void run() {

						if (protivnikovRed) {
							String tekst = "";
							int i = new Random().nextInt(13);
							i = deck.drawNextCard();

							protivnik.changeCardCount(i);
							System.out.println("Current card count: "
									+ protivnik.cardCount);
							sumaBodova += vrijednostiKarata[i];
							if (sumaBodova > 21 && asIzvucen && !asIskoristen) {
								sumaBodova -= 10;
								asIskoristen = true;
							}

							switch (i) {
							case 0:
								tekst = "Protivnik je vukao asa";
								asIzvucen = true;
								asIskoristen = false;
								break;
							case 1:
								tekst = "Protivnik je vukao dvojku";
								break;
							case 2:
								tekst = "Protivnik je vukao trojku";
								break;
							case 3:
								tekst = "Protivnik je vukao cetvorku";
								break;
							case 4:
								tekst = "Protivnik je vukao peticu";
								break;
							case 5:
								tekst = "Protivnik je vukao sesticu";
								break;
							case 6:
								tekst = "Protivnik je vukao sedmicu";
								break;
							case 7:
								tekst = "Protivnik je vukao osmicu";
								break;
							case 8:
								tekst = "Protivnik je vukao devetku";
								break;
							case 9:
								tekst = "Protivnik je vukao desetku";
								break;
							case 10:
								tekst = "Protivnik je vukao decka";
								break;
							case 11:
								tekst = "Protivnik je vukao damu";
								break;
							case 12:
								tekst = "Protivnik je vukao kralja";
								break;
							}
							if (sumaBodova > 21 && asIzvucen && !asIskoristen) {
								sumaBodova -= 10;
								asIskoristen = true;
							}
							labelaPovlacenja.setText(tekst);
							labelaBodova.setText("Suma bodova protivnika je "
									+ String.valueOf(sumaBodova));

							if (!protivnik.odluciPoBodovima(sumaBodova)) {
								protivnikovRed = false;
								djeliteljevRed = true;
								radnaDretvaDjelitelja.reset();
								radnaDretvaDjelitelja.sumaDjelitelja = 0;

								labelaBodova.setText("Konacna suma bodova: "
										+ String.valueOf(sumaBodova));

								System.out.println("Opponent stopping on "
										+ sumaBodova);
								return;
							}

						}
					}
				});
				try {
					Thread.sleep(3000);
				} catch (Exception ignorable) {
				}
			}
		}
	}

	private void initGUI() {
		JFileChooser jfc = new JFileChooser();
		if (jfc.showOpenDialog(IgraProtivAI.this) != JFileChooser.APPROVE_OPTION) {
			System.exit(-1);
		}

		// rad s datotekom
		Path openedFile = jfc.getSelectedFile().toPath();

		BufferedReader br = null;
		try {
			br = new BufferedReader(new InputStreamReader(
					new BufferedInputStream(new FileInputStream(openedFile
							.toFile().getAbsolutePath())), "UTF-8"));
		} catch (Exception e) {
			// ignore
		}

		try {
			String line = br.readLine(); // prva linija je nebitna
			line = br.readLine();
			String[] vrijednostiString = line.split(" ");
			line = br.readLine(); // ponovno ignore
			line = br.readLine();
			String[] odlukeString = line.split(" ");
			line = br.readLine(); // ignore
			line = br.readLine();
			String[] kljucneVrijednostiString = line.split(" ");

			double[] vrijednosti = new double[vrijednostiString.length];
			int[] odluke = new int[odlukeString.length];
			double[] kljucneVrijednosti = new double[kljucneVrijednostiString.length];

			for (int i = 0; i < vrijednosti.length; i++) {
				vrijednosti[i] = Double.parseDouble(vrijednostiString[i]);
				System.out.println("Vrijednost " + i + " je " + vrijednosti[i]);
			}

			for (int i = 0; i < odluke.length; i++) {
				odluke[i] = Integer.parseInt(odlukeString[i]);

			}
			for (int i = 0; i < kljucneVrijednosti.length; i++) {
				kljucneVrijednosti[i] = Double
						.parseDouble(kljucneVrijednostiString[i]);
			}

			protivnik = new AIprotivnik(vrijednosti, odluke, kljucneVrijednosti);
		} catch (Exception e) {
			System.exit(-1);
		}
		labelaPovlacenjaDjelitelja = new JLabel();
		labelaBodovaDjelitelja = new JLabel();
		labelaBodovaProtivnika = new JLabel();
		labelaPovlacenjaProtivnika = new JLabel();
		labelaPovlacenjaIgraca = new JLabel();
		labelaBodovaIgraca = new JLabel();
		hitGumbIgraca = new JButton();
		hitGumbIgraca.setText("HIT");
		standGumbIgraca = new JButton();
		standGumbIgraca.setText("STAND");

		labelaPobjedaAI = new JLabel();
		labelaPobjedaAINadIgracem = new JLabel();
		labelaPobjedaIgraca = new JLabel();
		labelaPobjedaIgracaNadAI = new JLabel();

		labelaPovlacenjaDjelitelja.setFont(new Font(Font.SANS_SERIF, Font.BOLD,
				22));
		labelaBodovaDjelitelja
				.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 22));
		labelaBodovaProtivnika
				.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 22));
		labelaPovlacenjaProtivnika.setFont(new Font(Font.SANS_SERIF, Font.BOLD,
				22));
		labelaPovlacenjaIgraca
				.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 22));
		labelaBodovaIgraca.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 22));

		hitGumbIgraca.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 15));
		standGumbIgraca.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 15));

		// gui namjestanje
		this.getContentPane().setSize(650, 600);
		this.getContentPane().setLayout(new GridLayout(1, 3));

		JPanel userPart = new JPanel();
		userPart.setBorder(BorderFactory.createTitledBorder("Korisnicki dio"));
		userPart.setLayout(new BoxLayout(userPart, BoxLayout.Y_AXIS));
		userPart.add(labelaPovlacenjaIgraca);
		userPart.add(labelaBodovaIgraca);
		userPart.add(hitGumbIgraca);
		userPart.add(standGumbIgraca);
		JLabel tekstIgrac1 = new JLabel("Broj pobjeda nad djeliteljem");
		tekstIgrac1.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 15));
		userPart.add(tekstIgrac1);
		labelaPobjedaIgraca.setText("0");
		userPart.add(labelaPobjedaIgraca);
		JLabel tekstIgrac2 = new JLabel("Broj pobjeda nad AI");
		tekstIgrac2.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 15));
		userPart.add(tekstIgrac2);
		labelaPobjedaIgracaNadAI.setText("0");
		userPart.add(labelaPobjedaIgracaNadAI);

		labelaPobjedaAI.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 15));
		labelaPobjedaIgraca.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 15));
		labelaPobjedaAINadIgracem.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 15));
		labelaPobjedaIgracaNadAI.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 15));

		JPanel AIPart = new JPanel();
		AIPart.setLayout(new BoxLayout(AIPart, BoxLayout.Y_AXIS));
		AIPart.setBorder(BorderFactory
				.createTitledBorder("Dio za umjetnu inteligenciju"));
		AIPart.add(labelaPovlacenjaProtivnika);
		AIPart.add(labelaBodovaProtivnika);
		JLabel tekstAI1 = new JLabel("Broj pobjeda nad djeliteljem");
		labelaPobjedaAI.setText("0");
		tekstAI1.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 15));
		AIPart.add(tekstAI1);
		AIPart.add(labelaPobjedaAI);
		JLabel tekstAI2 = new JLabel("Broj pobjeda nad korisnikom");
		tekstAI2.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 15));
		AIPart.add(tekstAI2);
		labelaPobjedaAINadIgracem.setText("0");
		AIPart.add(labelaPobjedaAINadIgracem);

		JPanel DealerPart = new JPanel();
		DealerPart.setLayout(new BoxLayout(DealerPart, BoxLayout.Y_AXIS));
		DealerPart.setBorder(BorderFactory
				.createTitledBorder("Dio za djelitelja"));
		DealerPart.add(labelaPovlacenjaDjelitelja);
		DealerPart.add(labelaBodovaDjelitelja);
		this.getContentPane().add(userPart);
		this.getContentPane().add(AIPart);
		this.getContentPane().add(DealerPart);
	}

	public static void main(String[] args) {

		SwingUtilities.invokeLater(new Runnable() {

			@Override
			public void run() {
				new IgraProtivAI().setVisible(true);
			}
		});

	}
}
